/*!
$Id: action_manager.h 296 2009-08-20 07:55:04Z horino $
*/
#ifndef ACTION_MANAGER_H
#define ACTION_MANAGER_H

#include "itl/vector.h"
#include "itl/functional.h"
#include "itl/algorithm.h"
#include "utilities.h"

namespace indi
{
	/*!
	\brief ANVGeBeBx[XNX
	\note păANVNX쐬܂
	*/
	class ActionEntity
	{
	public:
		ActionEntity() {}
		virtual ~ActionEntity(){}

		/*!
		\brief ANVV[PXe
		\note pŎRɎĂ(sKvȂ͎̂ȂĂǂ)
		*/
#define ACTION_SEQUENCE(id) virtual void id() {}
#include "action_manager.h"
#undef ACTION_SEQUENCE
	};

	/*!
	\brief ANV}l[WNX
	*/
	template<typename indi::u32 N>
	class ActionManager
	{
	public:
		ActionManager(){}
		~ActionManager(){ itl::For_each(_actions.begin(), _actions.end(), Delete()); }

		/*!
		\brief o^ĂeX̃ANVĂяoAANVV[PX
		*/
#define ACTION_SEQUENCE(id) void id() { itl::For_each(_actions.begin(), _actions.end(), Mem_fun(&ActionEntity::id)); }
#include "action_manager.h"
#undef ACTION_SEQUENCE

		/*!
		\brief ANV}l[W֓o^܂AXg̍Ōɒǉ܂
		\note ǉANṼCfbNXԂ܂
		*/
		u32 PushBack(ActionEntity *a) { u32 n(_actions.size()); _actions.push_back(a); return n; }

		/*!
		\brief CfbNXɂANZX
		*/
		ActionEntity *operator[](u32 i) const { ASSERT(i < _actions.size()); return _actions[i]; }

	private:
		itl::Vector<ActionEntity *, N> _actions;
	};
};

#endif //< ACTION_MANAGER_H

/*!
\brief ANṼV[PX̎ނ͂ő₵܂
*/
#ifdef ACTION_SEQUENCE
ACTION_SEQUENCE(Update) //< s
//ACTION_SEQUENCE(UpdateAfterCamera) //< J܂ĂĂ΂s
//ACTION_SEQUENCE(UpdateAfterCollision) //< RW̏IɌĂ΂s
#endif