/*!
$Id: algorithm.h 630 2009-12-21 07:52:59Z horino $
*/
#ifndef ALGORITHM_H
#define ALGORITHM_H

namespace indi
{
	namespace itl
	{
		template<typename I, typename F>
		F For_each(I first, I last, F func){
			for(;first!=last;++first)
				func(*first);
			return func;
		}

		template<typename I, typename T>
		I Find(I first, I last, const T &val){
			while(first!=last && !(*first==val))
				++first;
			return first;
		}

	};
};

#endif // ALGORITHM_H
