/*!
$Id: mesh_define.h 604 2009-12-11 06:59:00Z horino $
*/
#ifndef MESH_DEFINE_H
#define MESH_DEFINE_H

namespace indi
{
	namespace mesh
	{
		enum Vertex {
			Position = (1 << 0), 
			Normal = (1 << 1), 
			Color = (1 << 2), 
			Texture = (1 << 3), 
			Index = (1<< 4), 
			Weight = (1 << 5), 
			Index2 = (1<< 6), 
			Weight2 = (1 << 7), 
		};

		enum ProfileType {
			ProfileInvalid,
			ProfileCommon,
			ProfileCG,
			ProfileGLES,
			ProfileGLSL,
		};

		enum ShaderType {
			ConstantShader,
			LambertShader,
			PhongShader,
			BlinnShader,
		};

		enum TextureFlag {
			TextureValid = (1 << 0),
		};
	}
}

#endif // MESH_DEFINE_H