/*!
$Id: indi.cpp 512 2009-11-16 08:11:56Z horino $
*/
#include "stdafx.h"

#define INDI_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "indi.h"
#include "graphics/graphics.h"
#include "graphics/shader/shader.h"
#include "file/file_manager.h"
using namespace indi;

/*!
\brief indiLib̏
*/
void System::Initialize(const char *root)
{
	graphics::System::Initialize();
	//< VF[_̏
	graphics::shader::System::Initialize();
	//< t@CVXe
	file::FileManager::Create(root, 255);
	//< tXN[VF[_
	graphics::System::CreateFullScreenShader();
}

/*!
\brief indiLib̏I
*/
void System::Finalize()
{
	graphics::System::Finalize();
	graphics::shader::System::Finalize();
	file::FileManager::Release();
}