/*!
$Id: scenes.cpp 629 2009-12-21 04:06:49Z horino $
*/
#include "stdafx.h"

#define SCENES_CPP

#include "utilities.h"
#include "mesh/scenes.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::Scenes::Read(const u8 *data)
{
	const u8 *p(data);

	//< V[̌
	_scene_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_scene_num);
	if(_scene_num){
		//< V[
		_scenes = new Scene *[_scene_num];
		for(u32 i=0;i<_scene_num;++i){
			_scenes[i] = SceneCreator();
			p += _scenes[i]->Read(p);
			_scenes[i]->CreateControllerIndices(0);
		}
	}

	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::ScenesAABB::Read(const u8 *data)
{
	u32 ret(mesh::Scenes::Read(data));

	for(u32 i=0;i<_scene_num;++i)
		(*this) += *static_cast<mesh::SceneAABB *>(_scenes[i]);

	return ret;
}

