/*!
$Id: vertexbuffer_specialization.cpp 521 2009-11-18 05:33:43Z horino $
*/
/*!
  \note PS3ł̓ev[gwb_t@CɏȂƂ܂Ȃ̂ŁA
  ̃t@Cvertexbuffer.hCN[h܂BiϑIj
  ̃t@C̓vWFNgւ͒ǉȂłBiCN[hpr̂݁j
*/

/*!
\brief ev[g(VertexPosition)
*/
template<>
void VertexBuffer<VertexPosition>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 1)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
}

/*!
\brief ev[g(VertexPositionColor)
*/
template<>
void VertexBuffer<VertexPositionColor>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 2)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(4, GL_FLOAT, GL_COLOR_ARRAY, 12);
}

/*!
\brief ev[g(VertexPositionTexture)
*/
template<>
void VertexBuffer<VertexPositionTexture>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 2)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(2, GL_FLOAT, GL_TEXTURE_COORD_ARRAY, 12);
}

/*!
\brief ev[g(VertexPositionNormal)
*/
template<>
void VertexBuffer<VertexPositionNormal>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 2)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_NORMAL_ARRAY, 12);
}

/*!
\brief ev[g(VertexPositionNormalColor)
*/
template<>
void VertexBuffer<VertexPositionNormalColor>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 3)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_NORMAL_ARRAY, 12);
	_declaration[i++] = Declaration(4, GL_FLOAT, GL_COLOR_ARRAY, 12 + 12);
}

/*!
\brief ev[g(VertexPositionNormalTexture)
*/
template<>
void VertexBuffer<VertexPositionNormalTexture>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 3)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_NORMAL_ARRAY, 12);
	_declaration[i++] = Declaration(2, GL_FLOAT, GL_TEXTURE_COORD_ARRAY, 12 + 12);
}

/*!
\brief ev[g(VertexPositionNormalColorTexture)
*/
template<>
void VertexBuffer<VertexPositionNormalColorTexture>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 4)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_NORMAL_ARRAY, 12);
	_declaration[i++] = Declaration(4, GL_FLOAT, GL_COLOR_ARRAY, 12 + 12);
	_declaration[i++] = Declaration(2, GL_FLOAT, GL_TEXTURE_COORD_ARRAY, 12 + 12 + 16);
}

/*!
\brief ev[g(VertexPositionNormalIndexWeight)
*/
template<>
void VertexBuffer<VertexPositionNormalIndexWeight>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 5)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_NORMAL_ARRAY, 12);
	_declaration[i++] = Declaration(4, GL_FLOAT, GL_MATRIX_INDEX_ARRAY, 12 + 12);
	_declaration[i++] = Declaration(4, GL_FLOAT, GL_VERTEX_WEIGHT_ARRAY, 12 + 12 + 16);
}

/*!
\brief ev[g(VertexPositionNormalTextureIndexWeight)
*/
template<>
void VertexBuffer<VertexPositionNormalTextureIndexWeight>::CreateDeclaration() 
{
	_declaration = new Declaration[(_ndeclaration = 5)];
	u32 i = 0;
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_VERTEX_ARRAY, 0);
	_declaration[i++] = Declaration(3, GL_FLOAT, GL_NORMAL_ARRAY, 12);
	_declaration[i++] = Declaration(2, GL_FLOAT, GL_TEXTURE_COORD_ARRAY, 12 + 12);
	_declaration[i++] = Declaration(4, GL_FLOAT, GL_MATRIX_INDEX_ARRAY, 12 + 12 + 8);
	_declaration[i++] = Declaration(4, GL_FLOAT, GL_VERTEX_WEIGHT_ARRAY, 12 + 12 + 8 + 16);
}

//template class VertexBuffer<VertexPosition>;
//template class VertexBuffer<VertexPositionColor>;
//template class VertexBuffer<VertexPositionTexture>;
//template class VertexBuffer<VertexPositionNormal>;
//template class VertexBuffer<VertexPositionNormalColor>;
//template class VertexBuffer<VertexPositionNormalTexture>;
//template class VertexBuffer<VertexPositionNormalTextureIndexWeight>;
