/*!
$Id: main.cpp 595 2009-12-04 10:17:01Z horino $

}`_^[QbgTv

Px̃f`

EJ[}bv ... ʏ̊GeNX`֕`
Em[}}bv ... @eNX`֕`
EfvX}bv ... [xeNX`֕`

s܂B

ō쐬m[}}bvfvX}bv͌XAxVF[fBOVhE}bvŎgp܂
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
#include "font/font.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

//< OtHgNX  fontTvQ
class MyFont : public Font
{
public:
	MyFont(const char *path, graphics::shader::VertexProgram *vs, graphics::shader::PixelProgram *ps) : Font(path), _vs(vs), _ps(ps) {}
	virtual ~MyFont() {}

	f32 GetLineSpace() const { return 256.0f / 9.0f; }

	/*!
	  \brief `֐܂
	  \note 쐬ꂽtHgeNX`ɂ蕶̕т܂܂Ȃ̂ŁA[UŎKv
	  ̃P[Xł̓eNX`ł̕̕тgbL[Ȃ̂ŃR[h債Ă邪AтHv΂ƊȒPɂł(http://ash.jp/code/codetbl2.htm)̕тȂ炢̂
	*/
	f32 Draw(const char *s) {
		if(!IsLoaded()) return 0.0f;
		//< ؂oʒu肵܂
		f32 w(16.0f), h(GetLineSpace());
		f32 x, y;
		if(Is8BitChar(s[0])){ //< 1bytȅꍇ
			if(Isspace(s[0])){
				x = 15.0f * w;
				y = h * 8.0f;
			} else if(Isdigit(s[0])){
				if(s[0] >= '4'){
					y = h * 8.0f;
					x = static_cast<f32>(s[0] - '4') * w;
				} else {
					y = h * 7.0f;
					x = static_cast<f32>(s[0] - '0' + 11) * w;
				}
			} else if(Isalpha(s[0])){
				if(Islower(s[0])){
					if(s[0] >= 'p') {
						y = h * 7.0f;
						x = static_cast<f32>(s[0] - 'p') * w;
					} else {
						y = h * 6.0f;
						x = static_cast<f32>(s[0] - 'a') * w;
					}
				} else {
					if(s[0] >= 'P') {
						y = h * 7.0f;
						x = static_cast<f32>(s[0] - 'P') * w;
					} else {
						y = h * 6.0f;
						x = static_cast<f32>(s[0] - 'A') * w;
					}
				}
			} else 
				return 0.0f;
		} else { //< 2bytȅꍇ
			const u16 c(*reinterpret_cast<const u16 *>(s));
			if((c > 0x829e && c < 0x839e) || c == 0x8145 || c == 0x815b){ //< Ђ炪 ` J^Ji͈̔͂"["A"E"̂ݑΉ
				switch(c){
					//< "E"
				case 0x8145:             
					x = w * 10.0f; y = h * 5.0f;      
					break;
					//< "["
				case 0x815b:       
					x = w * 14.0f; y = h * 2.0f;      
					break;

					//< s
				case 0x8341: //< A
				case 0x82a0: //< 
					x = w * 0.0f; y = h * 0.0f;
					break;
				case 0x8341 + 2: //< C
				case 0x82a0 + 2: //< 
					x = w * 1.0f; y = h * 0.0f;
					break;
				case 0x8341 + 4: //< E
				case 0x82a0 + 4: //< 
					x = w * 2.0f; y = h * 0.0f;
					break;
				case 0x8341 + 6: //< G
				case 0x82a0 + 6: //< 
					x = w * 3.0f; y = h * 0.0f;
					break;
				case 0x8341 + 8: //< I
				case 0x82a0 + 8: //< 
					x = w * 4.0f; y = h * 0.0f;
					break;

					//< s
				case 0x8341 - 1:
				case 0x82a0 - 1:
					x = w * 10.0f; y = h * 1.0f;
					break;
				case 0x8341 + 2 - 1:
				case 0x82a0 + 2 - 1:
					x = w * 11.0f; y = h * 1.0f;
					break;
				case 0x8341 + 4 - 1:
				case 0x82a0 + 4 - 1:
					x = w * 12.0f; y = h * 1.0f;
					break;
				case 0x8341 + 6 - 1:
				case 0x82a0 + 6 - 1:
					x = w * 13.0f; y = h * 1.0f;
					break;
				case 0x8341 + 8 - 1:
				case 0x82a0 + 8 - 1:
					x = w * 14.0f; y = h * 1.0f;
					break;

					//< s
				case 0x8341 + 9:
				case 0x82a0 + 9:
					x = w * 5.0f; y = h * 0.0f;
					break;
				case 0x8341 + 11: 
				case 0x82a0 + 11: 
					x = w * 6.0f; y = h * 0.0f;
					break;
				case 0x8341 + 13: 
				case 0x82a0 + 13: 
					x = w * 7.0f; y = h * 0.0f;
					break;
				case 0x8341 + 15: 
				case 0x82a0 + 15: 
					x = w * 8.0f; y = h * 0.0f;
					break;
				case 0x8341 + 17: 
				case 0x82a0 + 17: 
					x = w * 9.0f; y = h * 0.0f;
					break;

					//< s
				case 0x8341 + 9 + 1:
				case 0x82a0 + 9 + 1:
					x = w * 0.0f; y = h * 4.0f;
					break;
				case 0x8341 + 11 + 1: 
				case 0x82a0 + 11 + 1: 
					x = w * 1.0f; y = h * 4.0f;
					break;
				case 0x8341 + 13 + 1: 
				case 0x82a0 + 13 + 1: 
					x = w * 2.0f; y = h * 4.0f;
					break;
				case 0x8341 + 15 + 1: 
				case 0x82a0 + 15 + 1: 
					x = w * 3.0f; y = h * 4.0f;
					break;
				case 0x8341 + 17 + 1: 
				case 0x82a0 + 17 + 1: 
					x = w * 4.0f; y = h * 4.0f;
					break;

					//< s
				case 0x8341 + 19:
				case 0x82a0 + 19:
					x = w * 10.0f; y = 0.0f;
					break;
				case 0x8341 + 21: 
				case 0x82a0 + 21: 
					x = w * 11.0f; y = 0.0f;
					break;
				case 0x8341 + 23: 
				case 0x82a0 + 23: 
					x = w * 12.0f; y = 0.0f;
					break;
				case 0x8341 + 25: 
				case 0x82a0 + 25: 
					x = w * 13.0f; y = 0.0f;
					break;
				case 0x8341 + 27: 
				case 0x82a0 + 27: 
					x = w * 14.0f; y = 0.0f;
					break;

					//< s
				case 0x8341 + 19 + 1:
				case 0x82a0 + 19 + 1:
					x = w * 5.0f; y = h * 4.0f;
					break;
				case 0x8341 + 21 + 1: 
				case 0x82a0 + 21 + 1: 
					x = w * 6.0f; y = h * 4.0f;
					break;
				case 0x8341 + 23 + 1: 
				case 0x82a0 + 23 + 1: 
					x = w * 7.0f; y = h * 4.0f;
					break;
				case 0x8341 + 25 + 1: 
				case 0x82a0 + 25 + 1: 
					x = w * 8.0f; y = h * 4.0f;
					break;
				case 0x8341 + 27 + 1: 
				case 0x82a0 + 27 + 1: 
					x = w * 9.0f; y = h * 4.0f;
					break;

					//< s
				case 0x8341 + 29:
				case 0x82a0 + 29:
					x = 0.0f; y = h;
					break;
				case 0x8341 + 31: 
				case 0x82a0 + 31: 
					x = w; y = h;
					break;
				case 0x8341 + 34: 
				case 0x82a0 + 34: 
					x = w * 2.0f; y = h;
					break;
				case 0x8341 + 36: 
				case 0x82a0 + 36: 
					x = w * 3.0f; y = h;
					break;
				case 0x8341 + 38: 
				case 0x82a0 + 38: 
					x = w * 4.0f; y = h;
					break;

					//< s
				case 0x8341 + 29 + 1:
				case 0x82a0 + 29 + 1:
					x = w * 10.0f; y = h * 4.0f;
					break;
				case 0x8341 + 31 + 1: 
				case 0x82a0 + 31 + 1: 
					x = w * 11.0f; y = h * 4.0f;
					break;
				case 0x8341 + 34 + 1: 
				case 0x82a0 + 34 + 1: 
					x = w * 12.0f; y = h * 4.0f;
					break;
				case 0x8341 + 36 + 1: 
				case 0x82a0 + 36 + 1: 
					x = w * 13.0f; y = h * 4.0f;
					break;
				case 0x8341 + 38 + 1:
				case 0x82a0 + 38 + 1: 
					x = w * 14.0f; y = h * 4.0f;
					break;

					//< 
				case 0x8362:
				case 0x82c1: 
					x = w * 13.0f; y = h * 3.0f;
					break;

					//< ȍs
				case 0x8341 + 40:
				case 0x82a0 + 40:
					x = w * 5.0f; y = h;
					break;
				case 0x8341 + 41: 
				case 0x82a0 + 41: 
					x = w * 6.0f; y = h;
					break;
				case 0x8341 + 42: 
				case 0x82a0 + 42: 
					x = w * 7.0f; y = h;
					break;
				case 0x8341 + 43: 
				case 0x82a0 + 43: 
					x = w * 8.0f; y = h;
					break;
				case 0x8341 + 44: 
				case 0x82a0 + 44: 
					x = w * 9.0f; y = h;
					break;

					//< ͍s
				case 0x8341 + 45:
				case 0x82a0 + 45:
					x = w * 0.0f; y = h * 2.0f;
					break;
				case 0x8341 + 48: 
				case 0x82a0 + 48: 
					x = w * 1.0f; y = h * 2.0f;
					break;
				case 0x8341 + 51: 
				case 0x82a0 + 51: 
					x = w * 2.0f; y = h * 2.0f;
					break;
				case 0x8341 + 54: 
				case 0x82a0 + 54: 
					x = w * 3.0f; y = h * 2.0f;
					break;
				case 0x8341 + 57: 
				case 0x82a0 + 57: 
					x = w * 4.0f; y = h * 2.0f;
					break;

					//< ΍s
				case 0x8341 + 45 + 1:
				case 0x82a0 + 45 + 1:
					x = w * 0.0f; y = h * 5.0f;
					break;
				case 0x8341 + 48 + 1: 
				case 0x82a0 + 48 + 1: 
					x = w * 1.0f; y = h * 5.0f;
					break;
				case 0x8341 + 51 + 1: 
				case 0x82a0 + 51 + 1: 
					x = w * 2.0f; y = h * 5.0f;
					break;
				case 0x8341 + 54 + 1: 
				case 0x82a0 + 54 + 1: 
					x = w * 3.0f; y = h * 5.0f;
					break;
				case 0x8341 + 57 + 1: 
				case 0x82a0 + 57 + 1: 
					x = w * 4.0f; y = h * 5.0f;
					break;

					//< ύs
				case 0x8341 + 45 + 2:
				case 0x82a0 + 45 + 2:
					x = w * 5.0f; y = h * 5.0f;
					break;
				case 0x8341 + 48 + 2: 
				case 0x82a0 + 48 + 2: 
					x = w * 6.0f; y = h * 5.0f;
					break;
				case 0x8341 + 51 + 2: 
				case 0x82a0 + 51 + 2: 
					x = w * 7.0f; y = h * 5.0f;
					break;
				case 0x8341 + 54 + 2: 
				case 0x82a0 + 54 + 2: 
					x = w * 8.0f; y = h * 5.0f;
					break;
				case 0x8341 + 57 + 2: 
				case 0x82a0 + 57 + 2: 
					x = w * 9.0f; y = h * 5.0f;
					break;

					//< ܍s
				case 0x8341 + 60:
				case 0x82a0 + 60:
					x = w * 5.0f; y = h * 2.0f;
					break;
				case 0x8341 + 61: 
				case 0x82a0 + 61: 
					x = w * 6.0f; y = h * 2.0f;
					break;
				case 0x8341 + 63:
				case 0x82a0 + 62: 
					x = w * 7.0f; y = h * 2.0f;
					break;
				case 0x8341 + 64: 
				case 0x82a0 + 63: 
					x = w * 8.0f; y = h * 2.0f;
					break;
				case 0x8341 + 65: 
				case 0x82a0 + 64:
					x = w * 9.0f; y = h * 2.0f;
					break;

					//< s
				case 0x8341 + 67:
				case 0x82a0 + 66:
					x = w * 10.0f; y = h * 2.0f;
					break;
				case 0x8341 + 69: 
				case 0x82a0 + 68: 
					x = w * 11.0f; y = h * 2.0f;
					break;
				case 0x8341 + 71: 
				case 0x82a0 + 70: 
					x = w * 12.0f; y = h * 2.0f;
					break;

					//< s
				case 0x8341 + 67 -1:
				case 0x82a0 + 66 -1:
					x = w * 10.0f; y = h * 3.0f;
					break;
				case 0x8341 + 69 -1: 
				case 0x82a0 + 68 -1: 
					x = w * 11.0f; y = h * 3.0f;
					break;
				case 0x8341 + 71 -1: 
				case 0x82a0 + 70 -1: 
					x = w * 12.0f; y = h * 3.0f;
					break;

					//< s
				case 0x8341 + 72:
				case 0x82a0 + 71:
					x = w * 0.0f; y = h * 3.0f;
					break;
				case 0x8341 + 73: 
				case 0x82a0 + 72: 
					x = w * 1.0f; y = h * 3.0f;
					break;
				case 0x8341 + 74: 
				case 0x82a0 + 73: 
					x = w * 2.0f; y = h * 3.0f;
					break;
				case 0x8341 + 75: 
				case 0x82a0 + 74: 
					x = w * 3.0f; y = h * 3.0f;
					break;
				case 0x8341 + 76: 
				case 0x82a0 + 75: 
					x = w * 4.0f; y = h * 3.0f;
					break;

					//< 
				case 0x8341 + 78 -1:
				case 0x82a0 + 77 -1:
					x = w * 14.0f; y = h * 3.0f;
					break;

					//< s
				case 0x8341 + 78:
				case 0x82a0 + 77:
					x = w * 5.0f; y = h * 3.0f;
					break;
				case 0x8341 + 81: 
				case 0x82a0 + 80: 
					x = w * 6.0f; y = h * 3.0f;
					break;
				case 0x8341 + 82: 
				case 0x82a0 + 81: 
					x = w * 7.0f; y = h * 3.0f;
					break;

				default:
					return 0.0f;
				}
			}
		}

		CutOrigin() = Vector2(x, y);
		CutSize() = Vector2(w, h);

		_world = GetMatrix();
		_cut = GetTexcoord();
		_alpha = Alpha();
		graphics::shader::Parameter::AutoBeginTexture auto_tex(_smp, this);

		_plane.Begin();{
			_plane.Draw();
		} _plane.End();

		return w;
	}

	void Begin() {
		if(_vs->IsLoaded() && _ps->IsLoaded()){
			_vs->Begin();
			_ps->Begin();
		}
	}
	void End() {
		if(_vs->IsLoaded() && _ps->IsLoaded()){
			_vs->End();
			_ps->End();
		}
	}

	void OnLoaded() {
		Font::OnLoaded();

		_world = _vs->GetParameter("World");
		_cut = _vs->GetParameter("CutTexcoord");
		_smp = _ps->GetParameter("Sampler");
		_alpha = _ps->GetParameter("Alpha");
	}

private:
	graphics::shader::VertexProgram *_vs;
	graphics::shader::PixelProgram *_ps;
	graphics::shader::Parameter _world;
	graphics::shader::Parameter _cut;
	graphics::shader::Parameter _smp;
	graphics::shader::Parameter _alpha;
	primitive::ScreenPlane _plane;
};

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 50.f, 1000.0f));

	//< eNX`fobO\p̃v[
	primitive::ScreenPlane plane;
	//< nʗpv[
	primitive::PlaneZX ground;

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("duck.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("duck.scn"));

	//< }`_pVF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("multi_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("multi_ps"SH_EXT));
	//< eNX`ւ̃_OpVF[_
	graphics::shader::VertexProgram *render_vs(new graphics::shader::VertexProgram("render_texture_vs"SH_EXT));
	graphics::shader::PixelProgram *render_ps(new graphics::shader::PixelProgram("render_texture_ps"SH_EXT));

	//u32 width(graphics::System::GetScreenWidth()), height(graphics::System::GetScreenHeight());
	u32 width(512), height(512);
	//< J[}bv
	graphics::RenderTexture *color_map(new graphics::RenderTexture(width, height)); 
	graphics::RenderTarget *color_target(new graphics::RenderTarget(color_map));
	//< m[}}bv
	graphics::RenderTexture *normal_map(new graphics::RenderTexture(width, height)); 
	graphics::RenderTarget *normal_target(new graphics::RenderTarget(normal_map));
	//< fvX}bv
	graphics::DepthTexture *depth_map(new graphics::DepthTexture(width, height)); 
	graphics::RenderTarget *depth_target(new graphics::RenderTarget(depth_map));
	//< Zobt@_^[Qbgi`̑O֌Wۂ߂ɕKvj
	graphics::DepthTarget *z_depth_target(new graphics::DepthTarget(width, height));
	//< }`_pt[obt@
	graphics::FrameBuffer *multi_buffer(new graphics::FrameBuffer(color_target, normal_target, depth_target, z_depth_target));

	//< tHg
	graphics::shader::VertexProgram *spr_vs(new graphics::shader::VertexProgram("sprite_vs"SH_EXT));
	graphics::shader::PixelProgram *spr_ps(new graphics::shader::PixelProgram("sprite_ps"SH_EXT));
	MyFont *font(new MyFont("font.tex", spr_vs, spr_ps));
	font->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Left | Sprite::Top);

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();		

		//< t[obt@ւ̕`(ȉ̕`͉ʂɂ͕\܂)
		{
			graphics::FrameBuffer::AutoBegin auto_fb(multi_buffer); //< `挋ʂcolor_map, normal_map, depth_map

			graphics::System::Clear();

			//< VF[_ǂݍ݊ĂȂƂ`͂łȂ
			if(vs->IsLoaded() && ps->IsLoaded()){
				//< fƃeNX`ǂݍ܂ĂΕ`
				if(model->IsLoaded() && texture->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					//< {͖t[Ŏ擾̂͗ǂȂ(Tvł͉ǐd)
					graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
					graphics::shader::Parameter w(vs->GetParameter("World"));
					graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
					if(texture->GetTextureNum()) {
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0));

						//< nʂ`
						{
							f32 scale(300.0f);
							f32 wall(1.0f);

							Matrix44 m(Matrix44::Scale(scale));
							wvp = m * camera.ViewProjection();
							w = m;
							ground.Begin();{
								ground.Draw();
							} ground.End();

							m = Matrix44::Scale(scale, 1.0f, scale * wall) * Matrix44::RotationX(INDI_PI * 0.5f) * Matrix44::TranslationZ(-scale);
							wvp = m * camera.ViewProjection();
							w = m;
							ground.Begin();{
								ground.Draw();
							} ground.End();

							m = Matrix44::Scale(scale * wall, 1.0f, scale) * Matrix44::RotationZ(INDI_PI * 0.5f) * Matrix44::TranslationX(scale);
							wvp = m * camera.ViewProjection();
							w = m;
							ground.Begin();{
								ground.Draw();
							} ground.End();

							m = Matrix44::Scale(scale * wall, 1.0f, scale) * Matrix44::RotationZ(INDI_PI * 1.5f) * Matrix44::TranslationX(-scale);
							wvp = m * camera.ViewProjection();
							w = m;
							ground.Begin();{
								ground.Draw();
							} ground.End();
						}

						f32 x = -50.0f * 5;
						f32 z = 0.0f;
						for(u32 i=0;i<5;++i, x+=100.0f, z -= 100.0f){
							Matrix44 pos(Matrix44::Translation(x, 0.0f, z));
							wvp = pos * camera.ViewProjection();
							w = pos;

							model->Draw();
						}
					}
				}
			}
		}

		//< {^ĂƂ͑Sʕ\
		if(input.Current(0).A()) 
			graphics::System::SwapBuffers(depth_map);
		else if(input.Current(0).B()) 
			graphics::System::SwapBuffers(normal_map);
		else if(input.Current(0).X()) 
			graphics::System::SwapBuffers(color_map);
		else {
			//< obNobt@ǐXbvʁjւ̕`
			graphics::System::BeginBackBuffer(); {
				graphics::System::Clear();

				//< e}bv̌ʂ\
				if(render_vs->IsLoaded() && render_ps->IsLoaded()){
					f32 sq(math::Sqrt(3.0f)); // color, normal, deptĥRȂ̂
					u32 col(static_cast<u32>(sq) + (sq > static_cast<f32>(static_cast<u32>(sq)) ? 1 : 0));
					f32 ratio(1.0f / static_cast<f32>(col));

					graphics::System::DepthWrite(FALSE);{
						graphics::shader::Program::AutoBegin auto_vs(*render_vs);
						graphics::shader::Program::AutoBegin auto_psinPS(*render_ps);

						graphics::shader::Parameter wvp(render_vs->GetParameter("WorldViewProjection"));
						graphics::shader::Parameter smp(render_ps->GetParameter("Sampler"));

						u32 i(0);
						{   //< J[}bv
							wvp = Matrix44::Scale(ratio * 0.9f) * Matrix44::Translation((i % col) * ratio * 2.0f - (1.0f - ratio), -((i / col) * ratio * 2.0f - (1.0f - ratio)), 0);
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, color_map);

							plane.Begin();{
								plane.Draw();
							} plane.End();		
						} ++i;
						{   //< m[}}bv
							wvp = Matrix44::Scale(ratio * 0.9f) * Matrix44::Translation((i % col) * ratio * 2.0f - (1.0f - ratio), -((i / col) * ratio * 2.0f - (1.0f - ratio)), 0);
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, normal_map);

							plane.Begin();{
								plane.Draw();
							} plane.End();							
						} ++i;
						{   //< fvX}bv
							wvp = Matrix44::Scale(ratio * 0.9f) * Matrix44::Translation((i % col) * ratio * 2.0f - (1.0f - ratio), -((i / col) * ratio * 2.0f - (1.0f - ratio)), 0);
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, depth_map);

							plane.Begin();{
								plane.Draw();
							} plane.End();							
						} ++i;
					} graphics::System::DepthWrite(TRUE);
				}

				if(font->IsLoaded()){
					graphics::System::Blend::AutoBegin auto_blend;
					graphics::System::Blend::Set(graphics::System::Blend::SRC_ALPHA, graphics::System::Blend::INV_SRC_ALPHA);

					Font::AutoBegin font_auto(*font);

					font->LocateRatio(0.05f, 0.05f);
					font->Puts("J[}bv\n");

					font->LocateRatio(0.55f, 0.05f);
					font->Puts("m[}}bv\n");

					font->LocateRatio(0.05f, 0.55f);
					font->Puts("fvX}bv\n");
				}					
			} graphics::System::EndBackBuffer();

			//< obNobt@̃Xbv
			graphics::System::SwapBuffers();
		}
	}

	delete font;
	delete spr_ps;
	delete spr_vs;

	delete multi_buffer;
	delete z_depth_target;
	delete depth_target;
	delete depth_map;
	delete normal_target;
	delete normal_map;
	delete color_target;
	delete color_map;

	delete render_ps;
	delete render_vs;

	delete ps;
	delete vs;

	delete model;
	delete texture;

	System::Finalize();
}
