uniform float4x4 WorldViewProjection;

struct VS_IN
{
	float4 Position : POSITION;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float4 ScreenPosition : TEXCOORD0;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	Out.Position = mul(WorldViewProjection, In.Position);
	Out.ScreenPosition = Out.Position;

	return Out;
}
