uniform float4x4 WorldViewProjection;
uniform float4x4 World;

struct VS_IN
{
	float4 Position : POSITION;
	float3 Normal : NORMAL;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float3 Normal : TEXCOORD0;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	Out.Position = mul(WorldViewProjection, In.Position);
	Out.Normal = mul((float3x3)World, In.Normal);

	return Out;
}
