/*!
$Id: main.cpp 536 2009-11-20 02:57:07Z horino $

fPFœhԂ́AԃVvȃf̕`B
f͈ŁAeX̃m[hItZbgȂǂȂOB

*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "graphics/shader/shader.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 10.f, 1000.0f));

	//< f
	mesh::ScenesFile *model(new mesh::ScenesFile("duck.scn"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("color_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("color_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		graphics::System::BeginBackBuffer(); {
			graphics::System::Clear();

			//< VF[_ǂݍ݊ĂȂƂ`͂łȂ
			if(vs->IsLoaded() && ps->IsLoaded()){
				//< fǂݍ܂ĂΕ`
				if(model->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					//< {͖t[Ŏ擾̂͗ǂȂ(Tvł͉ǐd)
					vs->GetParameter("WorldViewProjection") = Matrix44::Identity() * camera.ViewProjection();
					ps->GetParameter("Color") = color::Green;

					model->Draw();
				}
			}
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();
	}

	delete ps;
	delete vs;

	delete model;

	System::Finalize();
}
