/*!
$Id: tiling.cpp 513 2009-11-16 08:25:50Z horino $
*/
#include "stdafx.h"

#define TILING_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "graphics/graphics.h"
#include "graphics/tiling.h"
using namespace indi;

u32 graphics::Tiling::_current_address = 0;

/*!
\brief ƍvfBP[ebh^COp̋`쐬܂
\param ʂ󂯂`z
\param 
\param 
\note ͂Ƃ肠Q(TODO)
*/
u32 graphics::Tiling::CreateTilingRects(D3DRECT *dst, u32 w, u32 h)
{
#if 1 // TODO
	u32 nsplit(2);
	switch(graphics::System::GetSampleType()){
		case graphics::System::SAMPLE_NONE:
            break;
        case graphics::System::SAMPLE_2:
            break;
		case graphics::System::SAMPLE_4:
			break;
	}	

	dst[0].x1 = 0; dst[0].y1 = 0;        dst[0].x2 = w; dst[0].y2 = (h >> 1);
	dst[1].x1 = 0; dst[1].y1 = (h >> 1); dst[1].x2 = w; dst[1].y2 = h;

	return nsplit;
#else
	dst[0].x1 = 0; dst[0].y1 = 0;  dst[0].x2 = w; dst[0].y2 = h;
	return 1;
#endif
}

/*!
\brief ^C̒ōő̕A߂܂
*/
 U32Vector2 graphics::Tiling::GetTileMax(D3DRECT *r, u32 n)
 {
	 U32Vector2 v(0, 0);
	 for(u32 i=0;i<n;++i) {
		 v.x = math::Max(static_cast<u32>(r[i].x2 - r[i].x1), v.x);
		 v.y = math::Max(static_cast<u32>(r[i].y2 - r[i].y1), v.y);
	 }
	 return v;
 }

/*!
\brief Tv̐ݒĕƍ𒲐܂
\param ݂̕ƍ
\param ^CP傫ꍇTRUEnĂ
*/
U32Vector2 &graphics::Tiling::AdjustTileSize(U32Vector2 &v, BOOL b)
{
	switch(graphics::System::GetSampleType()){
		case graphics::System::SAMPLE_NONE:
			v.x = GetNextMultiple(v.x, GPU_EDRAM_TILE_WIDTH_1X);
			v.y = GetNextMultiple(v.y, GPU_EDRAM_TILE_HEIGHT_1X);
            break;
		case graphics::System::SAMPLE_2:
			v.x = GetNextMultiple(v.x, GPU_EDRAM_TILE_WIDTH_2X);
            v.y = GetNextMultiple(v.y, GPU_EDRAM_TILE_HEIGHT_2X);
            break;
        case graphics::System::SAMPLE_4:
			v.x = GetNextMultiple(v.x, GPU_EDRAM_TILE_WIDTH_4X);
			v.y = GetNextMultiple(v.y, GPU_EDRAM_TILE_HEIGHT_4X);
			break;
	}	
	if(b){
		v.x = GetNextMultiple(v.x, GPU_TEXTURE_TILE_DIMENSION);
		v.y = GetNextMultiple(v.y, GPU_TEXTURE_TILE_DIMENSION);
	}
	return v;
}