/*!
$Id: vector4.cpp 47 2009-06-25 09:29:29Z horino $
*/
#include "stdafx.h"

#define VECTOR4_CPP

#include "vector2.h"
#include "vector3.h"
#include "vector4.h"
#include "quaternion.h"

using namespace indi;

Vector4::Vector4(const Vector2 &v2, f32 z, f32 w) : _e(v2.X(), v2.Y(), z, w) {}
Vector4::Vector4(const Vector3 &v3, f32 w) : _e(v3.X(), v3.Y(), v3.Z(), w) {}
Vector4::Vector4(const Quaternion &q) : _e(q.X(), q.Y(), q.Z(), q.W()) {}
