/*!
$Id: colors.h 418 2009-10-15 10:10:51Z horino $
*/
#ifndef COLOR_H
#define COLOR_H

#include "vector3.h"
#include "vector4.h"
using namespace indi;

namespace color
{
	static const Vector4 White = Vector4::One();
	static const Vector4 Black = Vector4(Vector3::Zero(), 1.0f);
	static const Vector4 Red = Vector4(Vector3::UnitX(), 1.0f);
	static const Vector4 Green = Vector4(Vector3::UnitY(), 1.0f);
	static const Vector4 Blue = Vector4(Vector3::UnitZ(), 1.0f);
	static const Vector4 Yellow = Vector4(1.0f, 1.0f, 0.0f, 1.0f);
	static const Vector4 Gray = Vector4(0.5f, 0.5f, 0.5f, 1.0f);
};

#endif // COLOR_H