/*!
$Id: debug_stop.h 622 2009-12-16 10:10:00Z horino $
*/
#ifndef DEBUG_STOP_H
#define DEBUG_STOP_H

#include "indi.h"
#include "input/input.h"
#include "itl/bitset.h"

#ifdef _DEBUG
namespace indi
{
	class DebugStop 
	{
	public:
		enum {
			Stop,
			Step,
		};

		DebugStop() : _flag() {}
		virtual ~DebugStop(){}

		/*!
		\brief fobOXgbṽRg[
		\param PO̓
		\param ݂̓
		\note Back + StartŃfobOXgbv[h̃gOAXgbvStartŃR}B(ύXꍇ͌pControl()I[o[ChĂ)
		*/
		virtual void Control(const indi::Input::State &prevStat, const indi::Input::State &inpStat) {
			if(inpStat.Back()){
				if(!prevStat.Start() && inpStat.Start()) 
					_flag.Flip(Stop);
			} else {
				if(_flag.Test(Stop) && !prevStat.Start() && inpStat.Start())
					_flag.Set(Step);
				else
					_flag.Reset(Step);
			}
		}

		BOOL IsStop() const { return _flag.Test(Stop) && !_flag.Test(Step); }

	protected:
		itl::Bitset _flag;
	};
};
#endif

#endif // DEBUG_STOP_H