/*!
$Id: font.cpp 587 2009-12-02 02:23:49Z horino $
*/
#include "stdafx.h"

#define FONT_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "indi.h"
#include "graphics/graphics.h"
#include "font/font.h"
using namespace indi;

/*!
\brief tHg̃vbg
\param 
*/
void Font::Puts(const char *s)
{
	for(u32 i=0;i<Strlen(s);++i) {
		if(s[i] == '\n')
			SetPosition(_prev_x, GetPositionY() + static_cast<u32>(GetLineSpace() * Scale().Y()));
		else {
			f32 w(Draw(&s[i]));
			SetPosition(GetPositionX() + static_cast<u32>(w * Scale().X()), GetPositionY());
		}

		if(!Is8BitChar(s[i])) ++i;
	}
}

/*!
\brief tHg̃tH[}bgwvbg
\param 
*/
void Font::Printf(const char *fmt, ...)
{
	char s[512];
	va_list lst;
	va_start(lst, fmt);
	Vsprintf(s, fmt, lst);
	va_end(lst);
	Puts(s);
}

/*!
  \brief obt@ŏdelim܂ło܂
  \param obt@̐擪|C^
  \param o񂪊i[܂i\ȗ̈pӂĂj
  \return ̃obt@擪|C^Ԃ܂iobt@̍ŌɒBꍇ0Ԃ܂j
  \note obt@'\0'I[ĂKv܂ ӁIB
*/
const char *Font::Split(const char *buf, const char delim, char *dst)
{
	while(*buf != '\0'){
		if(Is8BitChar(*buf)){
			if(*buf == delim) {
				*dst = '\0';
				++buf;
				return buf;
			}
		} else
			*dst++ = *buf++;
		*dst++ = *buf++;		
	}
	*dst = '\0';
	return 0;
}