/*!
$Id: scene.cpp 629 2009-12-21 04:06:49Z horino $
*/
#include "stdafx.h"

#define SCENE_CPP

#include "utilities.h"
#include "mesh/scene.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::Scene::Read(const u8 *data)
{
	const u8 *p(data);

	//< m[ȟ
	_node_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_node_num);
	if(_node_num){
		//< m[h
		_nodes = new Node *[_node_num];
		for(u32 i=0;i<_node_num;++i){
			_nodes[i] = NodeCreator();
			p += _nodes[i]->Read(p);

			_nodes[i]->AccumulateTransform(); //< em[h̃gXtH[~
		}
	}
	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::SceneAABB::Read(const u8 *data)
{
	u32 ret(mesh::Scene::Read(data));

	for(u32 i=0;i<_node_num;++i)
		(*this) += *static_cast<mesh::NodeAABB *>(_nodes[i]);

	return ret;
}