/*!
$Id: scenes_texture.cpp 447 2009-10-26 09:25:56Z horino $
*/
#include "stdafx.h"

#define SCENES_TEXTURE_CPP

#include "utilities.h"
#include "mesh/scenes_texture.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::ScenesTexture::Read(const u8 *data)
{
	const u8 *p(data);

	_texture_num = *reinterpret_cast<const u32 *>(p); p+= sizeof(_texture_num);
	_textures = new graphics::TextureBase *[_texture_num];
	for(u32 i=0;i<_texture_num;++i){
		_textures[i] = new graphics::Texture();
		p += _textures[i]->Read(p);
	}

	return p - data;
}

