/*!
$Id: timer.cpp 599 2009-12-08 09:11:14Z horino $
*/
#include "stdafx.h"

#define TIMER_CPP

#include "timer.h"
#include "graphics/graphics.h"
using namespace indi;

/*!
\brief t[bPʂ̎֕ϊ܂
\param t[
*/
f32 Timer::ToSecond(u32 t)
{
	switch(graphics::System::GetFrameRate()){
	case graphics::System::FRAME_RATE_60: return static_cast<f32>(t) * 0.016666666666f;
	case graphics::System::FRAME_RATE_30: return static_cast<f32>(t) * 0.033333333333f;
	case graphics::System::FRAME_RATE_20: return static_cast<f32>(t) * 0.05f;
	case graphics::System::FRAME_RATE_15: return static_cast<f32>(t) * 0.066666666666f;
	default:
#ifdef _DEBUG
		ASSERT(0); 
#endif
		return 0.0f;
	}
}


u32 PowerOnTimer::current = 0;
u32 AnimationTimer::current = 0;
