/*!
$Id: file.h 623 2009-12-17 04:07:13Z horino $
*/
#ifndef FILE_H
#define FILE_H

#include <cell/cell_fs.h>

#include "typedefs.h"
#include "utilities.h"

namespace indi
{
	namespace file
	{
		/*!
		\brief t@C񓯊ǂݍ݃NX
		\note pĎgĂ
		*/
		class File
		{
		public:
			File();
			File(const char *path);
			virtual ~File();

			void Open(const char *path);
			void Close();
			void Load();
			void Release() { if(_aio.buf) { delete [] reinterpret_cast<char *>(_aio.buf); _aio.buf = 0; } }


			/*!
			\brief ǂݍ݂ƂɃR[obN܂
			\note pNXŎRɎĂ
			*/
			virtual void OnLoaded() = 0;

			/*!
			\brief ǂݍ݂̏
			\retval ܂ǂݍ݃NGXgoĂȂ TRUE
			\retval ǂݍ݂Ă鎞 TRUE
			\retval NGXgoāA܂ǂݍ݊ĂȂ FALSE
			*/
			BOOL IsLoaded() const { return GetRequestID() == Loaded; }

			u32 GetSize() { return _stat.st_size; }
			const u8 *GetData() const { return reinterpret_cast<const u8 *>(_aio.buf); }

			const s32 &GetRequestID() const { return _req_id; }
			s32 &GetRequestID() { return _req_id; }
			const u32 &GetIndex() const { return _index; }
			u32 &GetIndex() { return _index; }

			enum {
				NoRequest = -1,
				Callbacked = -2,
				Loaded = -3,
			};
		protected:
			CellFsAio _aio;
			CellFsStat _stat;
			s32 _req_id;
			u32 _index;
		};
	}
}

#endif // FILE_H