uniform sampler2D Sampler;

struct PS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	Out.Color = tex2D(Sampler, In.Texcoord);

	return Out;
}

