uniform sampler2D Sampler0;
uniform sampler2D Sampler1;
uniform float Ambient;

struct PS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	Out.Color = tex2D(Sampler0, In.Texcoord) * (Ambient + tex2D(Sampler1, In.Texcoord));

	return Out;
}
