uniform samplerCUBE Sampler;

struct PS_IN
{
	float4 Position : POSITION;
	float3 Position3D : TEXCOORD0;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main(PS_IN In)
{
	PS_OUT Out;

	Out.Color = texCUBE(Sampler, In.Position3D);

	return Out;
}
