uniform float4x4 WorldViewProjection;

struct VS_IN
{
	float4 Position : POSITION;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float3 Position3D : TEXCOORD0;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	Out.Position = mul(WorldViewProjection, In.Position);
	Out.Position3D = float3(In.Position.x, In.Position.y, In.Position.z);

	return Out;
}
