uniform sampler2D Sampler;
uniform float Alpha;

struct PS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	Out.Color = tex2D(Sampler, In.Texcoord);
	Out.Color.a *= Alpha;

	return Out;
}
