/*!
$Id: file.cpp 444 2009-10-23 09:53:28Z horino $
*/
#include "stdafx.h"

#define FILE_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "file/file_manager.h"
#include "file/file.h"
using namespace indi;

/*!
\brief fXgN^
*/
file::File::~File()
{
	FileManager::Get()->UnRegist(this);
	Release();
	Close();
}

/*!
\brief t@C̃I[v
*/
void file::File::Open(const char *path)
{
	char fullpath[BUFFER_SIZE];
	Strncpy(fullpath, FileManager::Get()->GetMountPoint(), sizeof(fullpath));
	Strcat(fullpath, path);
	_file_handle = CreateFile(fullpath, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	ASSERT(INVALID_HANDLE_VALUE != _file_handle);	

	//< t@CoĂ(fobOp)
#ifdef _DEBUG
	Strncpy(_file_name, path, sizeof(_file_name));
#endif
}

/*!
\brief t@C̃N[Y
*/
void file::File::Close()
{
	if(_file_handle) { CloseHandle(_file_handle); _file_handle = 0; }
	if(_thread_handle) { CloseHandle(_thread_handle); _thread_handle = 0; }
}

/*!
\brief t@Cǂݍ݂̃NGXg𔭍s܂
*/
void file::File::Load()
{
	ASSERT(_file_handle);
	//< ̃A[P[g̓e|prŎgq[v֊mۂAǂݍ݂Iėpς񂾂Ă܂
	_data = new u8 [(_size = GetFileSize(_file_handle, NULL))];
	_index = FileManager::Get()->Regist(this);
}